----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:38:47 02/11/2010 
-- Design Name: 
-- Module Name:    7segment - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity sevsegment is
	Port(
		bcd : in STD_LOGIC_VECTOR (3 downto 0);
		segment : out STD_LOGIC_VECTOR ( 6 downto 0 )
	);
end sevsegment;

architecture Behavioral of sevsegment is
	signal A : STD_LOGIC;
	signal B : STD_LOGIC;
	signal C : STD_LOGIC;
	signal D : STD_LOGIC;
	signal AN : STD_LOGIC;
	signal BN : STD_LOGIC;
	signal CN : STD_LOGIC;
	signal DN : STD_LOGIC;
begin
	A <= bcd(3);
	B <= bcd(2);
	C <= bcd(1);
	D <= bcd(0);
	AN <= not bcd(3);
	BN <= not bcd(2);
	CN <= not bcd(1);
	DN <= not bcd(0);

--Fa = CD' + B'D' + BC + A'C + A'BD + AB'C'
--Fb = B'D' + B'C' + A'B' + A'C'D' + A'CD + AC'D
--Fc = C'D + B'D + B'C' + A'D + A'C' + A'B + AB'
--Fd = B'C'D' + B'CD + BC'D + BCD' + A'CD' + A'B'D' + A'B'C + AC'D' + ABD' + ABC'
--Fe = CD' + B'D' + AD' + AC + AB
--Ff = AC + AB' + B'C'D' + BCD' + A'C'D' + A'BD' + A'BC'
--Fg = A + CD' + B'C + BD' + BC'

	segment(0) <= not ((C and DN) or (BN and DN) or (B and C) or (AN and C) or (AN and B and D) or (A and BN and CN));
	segment(1) <= not ((BN and DN) or (BN and CN) or (AN and BN) or (AN and CN and DN) or (AN and C and D) or (A and CN and D));
	segment(2) <= not ((CN and D) or (BN and D) or (BN and CN) or (AN and D) or (AN and CN) or (AN and B) or (A and BN));
	segment(3) <= not ((BN and CN and DN) or (BN and C and D) or (B and CN and D) or (B and C and DN) or (AN and C and DN) or (AN and BN and DN) or (AN and BN and C) or (A and CN and DN) or (A and B and DN) or (A and B and CN));
	segment(4) <= not ((C and DN) or (BN and DN) or (A and DN) or (A and C) or (A and B));
	segment(5) <= not ((A and C) or (A and BN) or (BN and CN and DN) or (B and C and DN) or (AN and CN and DN) or (AN and B and DN) or (AN and B and CN));
	segment(6) <= not ((A) or (C and DN) or (BN and C) or (B and DN) or (B and CN));

end Behavioral;

