----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:04:20 04/12/2010 
-- Design Name: 
-- Module Name:    project4 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity project4 is
	Port(
		hardware_clock : in STD_LOGIC;
		clear : in STD_LOGIC;
		input : in STD_LOGIC_VECTOR (7 downto 0);
		enter : in STD_LOGIC;
		action : in STD_LOGIC;
		s : in STD_LOGIC_VECTOR (1 downto 0);
		led : out STD_LOGIC_VECTOR (7 downto 0);
		anode : out STD_LOGIC_VECTOR (3 downto 0);
		segment_out : out STD_LOGIC_VECTOR (6 downto 0)
	);

end project4;

architecture Behavioral of project4 is

component counter is
	Port(
		clock : in STD_LOGIC;
		clear : in STD_LOGIC;
		count : in STD_LOGIC;
		q : out STD_LOGIC_VECTOR (15 downto 0)
		);
end component;

component clockdivider is
    Port (
		clock : in  STD_LOGIC;
      reset : in  STD_LOGIC;
		clockout : out  STD_LOGIC
		);
end component;

component clockdivider2 is
    Port (
		clock : in  STD_LOGIC;
      reset : in  STD_LOGIC;
		clockout : out  STD_LOGIC
		);
end component;

component stack is
	Port (
		clock : in STD_LOGIC;
		action : in STD_LOGIC;
		op : in STD_LOGIC;
		data_in : in STD_LOGIC_VECTOR (7 downto 0);
		stack0: out STD_LOGIC_VECTOR (7 downto 0);
		stack1: out STD_LOGIC_VECTOR (7 downto 0);
		stack2: out STD_LOGIC_VECTOR (7 downto 0);
		stack3: out STD_LOGIC_VECTOR (7 downto 0)
		);
end component;

component ALU is
	Port(
		s : in STD_LOGIC_VECTOR (1 downto 0);
		a : in STD_LOGIC_VECTOR (7 downto 0);
		b : in STD_LOGIC_VECTOR (7 downto 0);
		f : out STD_LOGIC_VECTOR (7 downto 0);
		cout : out STD_LOGIC
		);
end component;

component display is
	Port(
		display1 : in STD_LOGIC_VECTOR (15 downto 0);
		segment0 : out STD_LOGIC_VECTOR (6 downto 0);
		segment1 : out STD_LOGIC_VECTOR (6 downto 0);
		segment2 : out STD_LOGIC_VECTOR (6 downto 0);
		segment3 : out STD_LOGIC_VECTOR (6 downto 0)
	);
end component;

signal display1 : STD_LOGIC_VECTOR (15 downto 0);
signal segment0 : STD_LOGIC_VECTOR (6 downto 0);
signal segment1 : STD_LOGIC_VECTOR (6 downto 0);
signal segment2 : STD_LOGIC_VECTOR (6 downto 0);
signal segment3 : STD_LOGIC_VECTOR (6 downto 0);
signal temp_anode : STD_LOGIC_VECTOR (3 downto 0);

signal a : STD_LOGIC_VECTOR (7 downto 0);
signal b : STD_LOGIC_VECTOR (7 downto 0);
signal c : STD_LOGIC_VECTOR (7 downto 0);
signal d : STD_LOGIC_VECTOR (7 downto 0);

signal f : STD_LOGIC_VECTOR (7 downto 0);
signal push : STD_LOGIC_VECTOR (7 downto 0);

signal clocksig : STD_LOGIC;
signal clocksig2 : STD_LOGIC;
signal count : STD_LOGIC;
signal q : STD_LOGIC_VECTOR (15 downto 0);
signal q2 : STD_LOGIC_VECTOR (15 downto 0);

signal op : STD_LOGIC;

begin
	count <= '1';
	
	push(0) <= (input(0) and enter) or (f(0) and (not enter));
	push(1) <= (input(1) and enter) or (f(1) and (not enter));
	push(2) <= (input(2) and enter) or (f(2) and (not enter));
	push(3) <= (input(3) and enter) or (f(3) and (not enter));
	push(4) <= (input(4) and enter) or (f(4) and (not enter));
	push(5) <= (input(5) and enter) or (f(5) and (not enter));
	push(6) <= (input(6) and enter) or (f(6) and (not enter));
	push(7) <= (input(7) and enter) or (f(7) and (not enter));
	
	op <= enter;

	divider_component: clockdivider
		port map (hardware_clock, clear, clocksig);
		
	divider_component2: clockdivider2
		port map (hardware_clock, clear, clocksig2);

	counter_component: counter
		port map (clocksig, clear, count, q);

	counter_component2: counter
		port map (clocksig2, clear, count, q2);


	stack_component: stack
		port map (clocksig2, action, op, push, a, b, c, d);

	alu_component: ALU
		port map (s, a, b, f);
		
	display1(0) <= f(0);
	display1(1) <= f(1);
	display1(2) <= f(2);
	display1(3) <= f(3);
	display1(4) <= f(4);
	display1(5) <= f(5);
	display1(6) <= f(6);
	display1(7) <= f(7);
	display1(8) <= '0';
	display1(9) <= '0';
	display1(10) <= '0';
	display1(11) <= '0';
	display1(12) <= '0';
	display1(13) <= '0';
	display1(14) <= '0';
	display1(15) <= '0';
	
	display_component: display
		port map (display1, segment0, segment1, segment2, segment3);
		

	temp_anode(0) <= not q(0) and not q(1);
	temp_anode(1) <= q(0) and not q(1);
	temp_anode(2) <= not q(0) and q(1);
	temp_anode(3) <= q(0) and q(1);


	led(0) <= q2(0);
	led(1) <= q2(1);
	led(2) <= q2(2);
	led(3) <= q2(3);
	led(4) <= q2(4);
	led(5) <= q2(5);
	led(6) <= q2(6);
	led(7) <= q2(7);
		
	segment_out(0) <= (segment0(0) and temp_anode(0)) or (segment1(0) and temp_anode(1)) or (segment2(0) and temp_anode(2)) or (segment3(0) and temp_anode(3));
	segment_out(1) <= (segment0(1) and temp_anode(0)) or (segment1(1) and temp_anode(1)) or (segment2(1) and temp_anode(2)) or (segment3(1) and temp_anode(3));
	segment_out(2) <= (segment0(2) and temp_anode(0)) or (segment1(2) and temp_anode(1)) or (segment2(2) and temp_anode(2)) or (segment3(2) and temp_anode(3));
	segment_out(3) <= (segment0(3) and temp_anode(0)) or (segment1(3) and temp_anode(1)) or (segment2(3) and temp_anode(2)) or (segment3(3) and temp_anode(3));
	segment_out(4) <= (segment0(4) and temp_anode(0)) or (segment1(4) and temp_anode(1)) or (segment2(4) and temp_anode(2)) or (segment3(4) and temp_anode(3));
	segment_out(5) <= (segment0(5) and temp_anode(0)) or (segment1(5) and temp_anode(1)) or (segment2(5) and temp_anode(2)) or (segment3(5) and temp_anode(3));
	segment_out(6) <= (segment0(6) and temp_anode(0)) or (segment1(6) and temp_anode(1)) or (segment2(6) and temp_anode(2)) or (segment3(6) and temp_anode(3));
	anode <= not temp_anode;



end Behavioral;

