----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:20:35 04/12/2010 
-- Design Name: 
-- Module Name:    stack - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity stack is
	Port (
		clock : in STD_LOGIC;
		action : in STD_LOGIC;
		op : in STD_LOGIC;
		data_in : in STD_LOGIC_VECTOR (7 downto 0);
		stack0: out STD_LOGIC_VECTOR (7 downto 0);
		stack1: out STD_LOGIC_VECTOR (7 downto 0);
		stack2: out STD_LOGIC_VECTOR (7 downto 0);
		stack3: out STD_LOGIC_VECTOR (7 downto 0)
		);
end stack;

architecture Behavioral of stack is

signal tstack0 : STD_LOGIC_VECTOR (7 downto 0);
signal tstack1 : STD_LOGIC_VECTOR (7 downto 0);
signal tstack2 : STD_LOGIC_VECTOR (7 downto 0);
signal tstack3 : STD_LOGIC_VECTOR (7 downto 0);

begin

	process(tstack0, tstack1, tstack2, tstack3, data_in, action)
	begin
		if (clock='1' and clock'event) then
			if (action = '1') then
				if (op = '1') then
					tstack3 <= tstack2;
					tstack2 <= tstack1;
					tstack1 <= tstack0;
					tstack0 <= data_in;
				else
					tstack0 <= tstack1;
					tstack1 <= tstack2;
					tstack2 <= tstack3;
					tstack3 <= "00000000";
				end if;
			end if;
		end if;
	end process;

	stack0 <= tstack0;
	stack1 <= tstack1;
	stack2 <= tstack2;
	stack3 <= tstack3;


end Behavioral;

